/***********************************************************************

  ATTEST.C

***********************************************************************/

#include    <stdio.h>	    /* sprintf */
#include    <conio.h>	    /* _getch */
#include    <vs2.h>


/***********************************************************************

  FUNCTION PROTOTYPES

***********************************************************************/

void	main( int, char * * );


/***********************************************************************

  GLOBAL VARIABLES

***********************************************************************/

extern VIDEOSTATEPARAMS vsp;

static char szBanner1[] = "Int 10h function 13h (blink disabled)";
static char szBanner2[] = "Int 10h function 13h (blink enabled) ";
static char sz[4];


/***********************************************************************

  main

***********************************************************************/

void main( int argc, char * argv[] )
{
    USHORT  usMode, x, y;
    UCHAR   a, b, f;
    LPVDDA  lpVDDA = ADDRVDDA;


    /* clear the display */
    usMode = GetVMode();
printf( "GetVMode returns %04Xh", usMode );
_getch();
    SetVMode( usMode );
    InitVSP( usMode );
    SetBorder( 0x08 );		/* a colored border */

    /* figure out where to center the text to be displayed */
    x = vsp.usSX;
    y = vsp.usSY;

    if( (usMode > 3) && (usMode != 7) )
    {
      /* convert graphics-mode pixel dimensions to
      /*  character dimensions */
      x /= 8;
      y /= lpVDDA->Points;
    }

    x = (x-32) / 2;
    y = (y-18) / 2;

    for( b=0; b<16; b++ )
      for( f=0; f<16; f++ )
      {
	a = (UCHAR)((b<<4) | f);
	sprintf( sz, "%02X", a );
	TextAt( (USHORT)(x+2*f), (USHORT)(y+b), sz, a );
      }

    TextAt( 0, 0, szBanner1, 0x07 );
    SetBlink( FALSE );
    _getch();

    TextAt( 0, 0, szBanner2, 0x07 );
    SetBlink( TRUE );
    SetCursorXY( 0, 21 );
}
