		TITLE	FN00.ASM
		NAME	FN00
		PAGE	55,132

.286

INCLUDE 	vs2.inc

DGROUP		GROUP	_DATA

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'
		ASSUME	ds:DGROUP

		EXTRN	INITVSP:FAR
		EXTRN	Fn4F02:NEAR

; Fn00 -- select video mode
;
; Notes:
;   This function maps 8-bit video mode numbers to VESA modes
;   by adding a 16-bit constant.  This lets MS-DOS CLS clear
;   the screen by calling int 10h, functions 0Fh and 00h,
;   which gets and then resets the video mode.

		PUBLIC	Fn00
Fn00		PROC	NEAR

	cmp	al, M256ModeFirst
	jb	L000

	cmp	al, M256ModeLast
	ja	L000

; map the 8-bit BIOS mode number to a 16-bit VESA mode number
	mov	bx, VBEModeBase
	add	bl, al
	call	Fn4F02
	ret

; come here for non-VBE video modes
L000:	push	ax
	call	INITVSP

; chain to the previous int 10h handler
	pushf
	call	PrevISR10
	ret

Fn00		ENDP

VS2_TEXT	ENDS

_DATA		SEGMENT WORD PUBLIC 'DATA'

		EXTRN	VSP:VIDEOSTATEPARAMS
		EXTRN	PrevISR10:DWORD

_DATA		ENDS

		END
