		TITLE	FN0C.ASM
		NAME	FN0C
		PAGE	55,132

.286

INCLUDE 	vs2.inc

DGROUP		GROUP	_DATA

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'
		ASSUME	ds:DGROUP

		EXTRN	SETPIXEL256:FAR
		EXTRN	SwitchStack:NEAR
		EXTRN	UnswitchStack:NEAR

; Fn0C -- store pixel value

		PUBLIC	Fn0C
Fn0C		PROC	NEAR

	cmp	VSP.usMode, VBEModeFirst
	jb	L000
	cmp	VSP.usMode, VBEModeLast
	jbe	L001

; not an M256X mode, so just chain to the previous int 10h handler
L000:	pushf
	call	PrevISR10
	ret

; write the specified pixel
L001:	call	SwitchStack
	push	cx
	push	dx
	xor	ah, ah
	push	ax
	call	SETPIXEL256
	call	UnswitchStack
	ret

Fn0C		ENDP

VS2_TEXT	ENDS

_DATA		SEGMENT WORD PUBLIC 'DATA'

		EXTRN	VSP:VIDEOSTATEPARAMS
		EXTRN	PrevISR10:DWORD

_DATA		ENDS

		END
