/***********************************************************************

  SATEST.C

***********************************************************************/

#include    <stdio.h>	    /* printf sprintf */
#include    <conio.h>	    /* _getch() */
#include    <vs2.h>


/***********************************************************************

  FUNCTION PROTOTYPES

***********************************************************************/

void	    main( int, char * * );

/* defined in SAVEAREA.ASM */
void VS2API EstablishPSA( void );
void VS2API EstablishUPP( void );


/***********************************************************************

  GLOBAL VARIABLES

***********************************************************************/

/* defined in SAVEAREA.ASM */
extern ULONG	OldSavePtr;
extern ULONG	NewSPTable[7];
extern UCHAR	PSA[256];


/***********************************************************************

  main

***********************************************************************/

void main( int argc, char * argv[] )
{
    USHORT  usMode, r, c;
    char    szBuf[32];
    LPLONG  SAVE_PTR = (LPLONG)0x004000A8L;


    /* establish a ROM BIOS Parameter Save Area */
    EstablishPSA();

    /* reset the current video mode through the ROM BIOS in order */
    /*	to update the Parameter Save Area */
    usMode = GetVMode();
    SetVMode( usMode );
    InitVSP( usMode );
    SetBorder( 8 );

    /* display the contents of the Parameter Save Area */
    for( r=0; r<16; r++ )
    {
      for( c=0; c<16; c++ )
	printf( "%02X ", PSA[r*16+c] );

      printf( "\n" );
    }

    /* restore the default SAVE_PTR value */
    *SAVE_PTR = OldSavePtr;
    _getch();

    /* establish a "custom" 16-color palette */
    EstablishUPP();

    /* reset the current video mode through the ROM BIOS in order */
    /*	to update the Parameter Save Area */
    usMode = GetVMode();
    SetVMode( usMode );
    InitVSP( usMode );

    /* display all 16 character attributes */
    /* (the border color should have come from the custom table) */
    SetBlink( FALSE );
    for( r=0; r<16; r++ )
    {
      sprintf( szBuf, "This is attribute %02X", r );
      TextAt( 0, r, szBuf, (UCHAR)r );
    }

    /* restore the default SAVE_PTR value */
    *SAVE_PTR = OldSavePtr;
    _getch();
}
