/***********************************************************************

  SVM.C

***********************************************************************/

#include    <stdio.h>	    /* sscanf printf */
#include    <vs2.h>


/***********************************************************************

  FUNCTION PROTOTYPES

***********************************************************************/

int main( int, char * * );


/***********************************************************************

  main

***********************************************************************/

int main( int argc, char * * argv )
{
    USHORT  usMode;
    LPVDDA  lpVDDA = ADDRVDDA;


    /* verify command-line syntax */
    if( 2 != argc )
    {
      printf( "\nSyntax: SVM <hexadecimal BIOS mode number>\n" );
      return 3;
    }

    /* pass the mode number to the BIOS */
    sscanf( argv[1], "%x", &usMode );
    SetVMode( usMode );

    /* display the current video mode number */
    printf( "Current video mode is %02Xh\n", lpVDDA->CRTMode );

    return 0;
}
