		TITLE	CURSOR.ASM
		NAME	CURSOR
		PAGE	55,132

.286

INCLUDE 	vs2.inc

VS2_TEXT	SEGMENT BYTE PUBLIC 'CODE'

; SetCursorXY
;
;   void VS2API SetCursorXY( USHORT x, USHORT y );

; parameters
y		EQU	BYTE PTR [bp+6]
x		EQU	BYTE PTR [bp+8]

		PUBLIC	SETCURSORXY
SETCURSORXY	PROC	FAR

	enter	0, 0

	mov	dh, y
	mov	dl, x
	xor	bh, bh		; assume video page 0
	mov	ah, 2		; int 10h function number
	int	10h

	leave
	ret	4		; 2*sizeof(USHORT)

SETCURSORXY	ENDP

; GetCursorXY
;
;   void VS2API GetCursorXY( LPSHORT px, LPSHORT py );

; parameters
py		EQU	DWORD PTR [bp+6]
px		EQU	DWORD PTR [bp+10]

		PUBLIC	GETCURSORXY
GETCURSORXY	PROC	FAR

	enter	0, 0

	mov	ah, 0Fh 	; int 10h function number
	int	10h		; leaves BH = active video page

	mov	ah, 3		; int 10h function number
	int	10h

	mov	al, dl
	xor	ah, ah		; AX = cursor column
	les	bx, px		; ES:BX -> px
	mov	es:[bx], ax

	mov	al, dh		; AX = cursor row
	les	bx, py		; ES:BX -> py
	mov	es:[bx], ax

	leave
	ret	8		; 2*sizeof(LPSHORT)

GETCURSORXY	ENDP

; SetCursorSize
;
;   void VS2API SetCursorSize( USHORT Top, USHORT Bottom );

; parameters
Bottom		EQU	BYTE PTR [bp+6]
Top		EQU	BYTE PTR [bp+8]

		PUBLIC	SETCURSORSIZE
SETCURSORSIZE	PROC	FAR

	enter	0, 0

	mov	ch, Top
	mov	cl, Bottom
	mov	ah, 1		; int 10h function number
	int	10h

	leave
	ret	4		; 2*sizeof(USHORT)

SETCURSORSIZE	ENDP

VS2_TEXT	ENDS

		END
